package eu.telecomnancy.sensor;

public class AdapterLegacyTemperatureSensor implements ISensor {
	
	LegacyTemperatureSensor lts;
	

	public AdapterLegacyTemperatureSensor(LegacyTemperatureSensor lts) {
		super();
		this.lts = lts;
	}

	@Override
	public void on() {
		if(!lts.getStatus()){
			lts.onOff();
		}
	}

	@Override
	public void off() {
		if(lts.getStatus()){
			lts.onOff();
		}		
	}

	@Override
	public boolean getStatus() {
		return lts.getStatus();
	}

	@Override
	public void update() throws SensorNotActivatedException {
		if(this.getStatus()){
		this.off();
		this.on();
		} else {
			 throw new SensorNotActivatedException("Sensor must be activated before acquiring new values.");
		}
	}

	@Override
	public double getValue() throws SensorNotActivatedException {
		if (this.getStatus())
            return lts.getTemperature();
        else throw new SensorNotActivatedException("Sensor must be activated to get its value.");
	}

	
	
}
